#<profile4xi profile = "11"/>
# ---------------------------------------------------------------------------------------------
#<program4xi program = "test_token4xi.py">
#<abstract4xi abstract = "tests token4xi"/>
#<verify4xi verification = "10" target = "token4xi.py"/>
#<contextualize4xi context = "syncmanager4xi.py, server4xi.py, process4xi.py"/>
#<use4xi usage = "
# SETTINGS:
#   examone4xi.py - defines which version is being used
# RUN:
# 
# > call t  test_token4xi > ..\txt\test_token4xi.txt
#
# MONITOR:
#   OF TEST_TOKEN4XI
#
# ANALYZE:
# sense-token4xi.xml    
# reason-token4xi.xml
# ace-token4xi.xml
# test_token4xi.txt   
#"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_token4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import _winapi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Source ones
    from multiprocessing.managers import Server
except:
    print("test_token4xi.py: *** failed in from multiprocessing.managers import Server ***")
try:                             
    from multiprocessing.managers import SyncManager
except:
    print("test_token4xi.py: *** failed in from multiprocessing.managers import SyncManager ***")    
try:                             
    from multiprocessing.managers import Token
except:
    print("test_token4xi.py: *** failed in from multiprocessing.managers import Token ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from acquirerproxy4xi import AcquirerProxy4Xi
from after_fork4xi import AfterFork4Xi
from active_children4xi import active_children4xi
from answer_challenge4xi import answer_challenge4xi
from arbitrary_address4xi import arbitrary_address4xi
from array4xi import Array4Xi
from arrayproxy4xi import ArrayProxy4Xi
from autoproxy4xi import AutoProxy4Xi

from barrier4xi import Barrier4Xi
from barrierproxy4xi import BarrierProxy4Xi
from basemanager4xi import BaseManager4Xi 
from baseproxy4xi import BaseProxy4Xi

from current_process4xi import CurrentProcess4Xi
from current_process4xi import get_authkey_current_process4xi
from conditionproxy4xi import ConditionProxy4Xi
from constant_util4xi import ConstantUtil4Xi
from constant_connection4xi import ConstantConnection4Xi
from constant_family4xi import ConstantFamily4Xi
from constant_forking4xi import ConstantForking4Xi
from constant_heap4xi import ConstantHeap4Xi
from constant_logger4xi import ConstantLogger4Xi
from constant_managers4xi import ConstantManagers4Xi
from constant_pool4xi import ConstantPool4Xi
from constant_process4xi import ConstantProcess4Xi
from constant_synchronize4xi import ConstantSynchronize4Xi
from constant_system4xi import ConstantSystem4Xi
from constant_util4xi import ConstantUtil4Xi

from deliver_challenge4xi import deliver_challenge4xi
from dictproxy4xi import DictProxy4Xi
from dispatch4xi import dispatch4xi

from eventproxy4xi import EventProxy4Xi
from examine4xi import examine4xi

from finalize4xi import Finalize4Xi                 # use directly its registry and counter in the same way as Finalize4Xi class

from iteratorproxy4xi import IteratorProxy4Xi


from listener_client4xi import listener_client4xi
from listproxy4xi import ListProxy4Xi
from loop4xi import limit2loop4xi

from namespaceproxy4xi import NamespaceProxy4Xi
from namespace4xi import Namespace4Xi
from namespaceproxy4xi import NamespaceProxy4Xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      
from pipe4xi import Pipe4Xi
from poolproxy4xi import PoolProxy4Xi
from pool4xi import Pool4Xi
from process4xi import Process4Xi

from reason_object4xi import reason_object4xi

from sleep4xi import omega2sleep4xi 
from sense_object4xi import sense_object4xi
from server4xi import Server4Xi
from sleep4xi import omega2sleep4xi
from state4xi import State4Xi
from syncmanager4xi import SyncManager4Xi

from timeout4xi import omega2timeout4xi
from token4xi import Token4Xi

from value4xi import Value4Xi
from valueproxy4xi import ValueProxy4Xi

from _run_finalizers4xi import _run_finalizers4xi
from timeout4xi import omega2timeout4xi

from print4xi import print4xi
from print4xi import Print4Xi
from time4xi import time4xi  
from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF TEST_TOKEN4XI -OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF TEST_TOKEN4XI -OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF TEST_TOKEN4XI -OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF TEST_TOKEN4XI -OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33)  OF DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33)  OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33)  OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33)  OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33)  OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33)  OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33)  OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33)  OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33)  OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF TEST_TOKEN4XI -OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'active_children4xi': 'NACK4TRACE',
        'answer_challenge4xi': 'NACK4TRACE',
        'arbitrary_address4xi': 'NACK4TRACE',
        'AcquirerProxy4Xi': 'NACK4TRACE',
        'AfterFork4Xi': 'NACK4TRACE',
        'Array4Xi': 'NACK4TRACE',
        'ArrayProxy4Xi': 'NACK4TRACE',
        'AutoProxy4Xi': 'NACK4TRACE',
        'Barrier4Xi': 'NACK4TRACE',
        'BarrierProxy4Xi': 'NACK4TRACE',
        'BaseManager4Xi ': 'NACK4TRACE',
        'BaseProxy4Xi': 'NACK4TRACE',
        'CurrentProcess4Xi': 'NACK4TRACE',
        'get_authkey_current_process4xi': 'NACK4TRACE',
        ' ConditionProxy4Xi': 'NACK4TRACE',
        'ConstantUtil4Xi': 'NACK4TRACE',
        'ConstantConnection4Xi': 'NACK4TRACE',
        'ConstantFamily4Xi': 'NACK4TRACE',
        'ConstantForking4Xi': 'NACK4TRACE',
        'ConstantHeap4Xi': 'NACK4TRACE',
        'ConstantLogger4Xi': 'NACK4TRACE',
        'ConstantManagers4Xi': 'NACK4TRACE',
        'ConstantPool4Xi': 'NACK4TRACE',
        'ConstantProcess4Xi': 'NACK4TRACE',
        'ConstantSynchronize4Xi': 'NACK4TRACE',
        'ConstantSystem4Xi': 'NACK4TRACE',
        'ConstantUtil4Xi': 'NACK4TRACE',
        'deliver_challenge4xi': 'NACK4TRACE',
        'DictProxy4Xi': 'NACK4TRACE',
        'dispatch4xi': 'NACK4TRACE',
        'DummyProcess4Xi': 'NACK4TRACE',
        'EventProxy4Xi': 'NACK4TRACE',
        'Finalize4Xi': 'NACK4TRACE',
        'IteratorProxy4Xi': 'NACK4TRACE',
        'listener_client4xi': 'NACK4TRACE',
        'ListProxy4Xi': 'NACK4TRACE',
        'limit2loop4xi': 'NACK4TRACE',
        'NamespaceProxy4Xi': 'NACK4TRACE',
        'Namespace4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'PoolProxy4Xi': 'NACK4TRACE',
        'Pool4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'Server4Xi': 'NACK4TRACE',
        'State4Xi': 'NACK4TRACE',
        'SyncManager4Xi': 'NACK4TRACE',
        'Token4Xi': 'NACK4TRACE',
        'Value4Xi': 'NACK4TRACE',
        'ValueProxy4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-token4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Token4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Token4Xi in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-token4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Token4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Token4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-token4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Token4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Token4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_token4xi" usage = "
#  Token4Xi:
#     basemanager4xi.py
#         return Token4Xi(typeid, self._address, id), exposed
#     server4xi.py:
#         token2xi = Token4Xi(typeid2xi, self.address, rident2xi)
#     syncmanager4xi.py:
#         return Token4Xi(typeid, self._address, id), exposed"
# -------------------------------------------------------------------------------------------------    
def test_token4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0/33) OF TEST_TOKEN4XI - SET T2XI TO: ", t2xi)
    #  
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
                                     
               
    # ---------------------------------------------------------------------------------------------------------
    # START OF TESTS                          
    # ---------------------------------------------------------------------------------------------------------    
    print('(Step 0/33) OF TEST_TOKEN4XI - STARTING TEST_TOKEN4XI ', time4xi()) 
    # 07:01:50 04/25/13 Pacific Daylight Time 
       
    # ---------------------------------------------------------------------------------------------------------
    # ALL TRIALS OF TESTS                          
    # ---------------------------------------------------------------------------------------------------------    
    try:
    
        # Note: the following steps use Toke4Xi-class INTERNALLY
            
        # ---------------------------------------------------------------------------------------------
        # (STEP 1/33) OF TEST_TOKEN4XI - CREATE SYNCMANAGER4XI OBJECT                       
        # ---------------------------------------------------------------------------------------------   
        ack2manager = False
        
        manager2xi = None
        
        try:
            print("(Step 1A/33) OF TEST_TOKEN4XI - CREATING manager2xi object of SyncManager4Xi: ", SyncManager4Xi)
            # <class 'syncmanager4xi.SyncManager4Xi'>
             

            manager2xi = SyncManager4Xi()
            
            ack2manager = True
            
            print('=' *33)
            print("(Step 1B/33) OF TEST_TOKEN4XI - CREATED SYNC MANAGER manager2xi: ", manager2xi)
            # <syncmanager4xi.SyncManager4Xi object at 0x02D3CBD0> 
            print('=' *33)
        except:
            print('~' *33)
            print("\n (STEP 1Z/33) OF TEST_TOKEN4XI -***  FAILED TO CREATE SYNC MANAGER ***" , time4xi())
            print('~' *33)        
        
           
        # ---------------------------------------------------------------------------------------------
        # (STEP 2/33) OF TEST_TOKEN4XI - START                       
        # ---------------------------------------------------------------------------------------------   
        if ack2manager is True:
            ack2start = False
            try:    
                print('=' *33)
                print("\n (STEP 2A/33) OF TEST_TOKEN4XI - SPAWNING  A SERVER PROCESS FOR MANAGER OBJECT manager2xi: ", manager2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000002AD5C50>     
                        
                manager2xi.start()
                
                ack2start = True
                
                print('=' *33)
                print("\n (STEP 2B/33) OF TEST_TOKEN4XI - SPAWNED A SERVER PROCESS FOR MANAGER OBJECT manager2xi: ", manager2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x02D3CBD0>
            except:
                print('~' *33)
                print("\n (STEP 2Z/33) OF TEST_TOKEN4XI - *** FAILED TO SPAWN A SERVER PROCESS FOR MANAGER OBJECT manager2xi: ", manager2xi)
                print('~' *33)                
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30> <-- new
        else:
            print('~' *33)
            print("\n (STEP 2C/33) OF TEST_TOKEN4XI - ** SKIPPED SPAWNING A SERVER PROCESS FOR MANAGER OBJECT manager2xi: ", manager2xi)
            print('~' *33)                       
           
        # ---------------------------------------------------------------------------------------------
        # (STEP 4/33) OF TEST_TOKEN4XI - GETTING A SERVER OBJECT                   
        # ---------------------------------------------------------------------------------------------   
        server2xi = None
        ack2server = False
        
        if ack2manager is True:
            
            
            try:              
                print('=' *33)
                print("\n (STEP 4A/33) OF TEST_TOKEN4XI - GETTING A SERVER OBJECT FROM MANAGER OBJECT manager2xi: ", manager2xi)
                print('=' *33)
                     
                server2xi = manager2xi.get_server()
                
                ack2server = True
                
                print('=' *33)
                print("\n (STEP 4B/33) OF TEST_TOKEN4XI - GOT A SERVER OBJECT server2xi: ", server2xi)
                print('=' *33)
                # <server4xi.Server4Xi object at 0x0000000003CBABE0>
            except:
                print('=' *33)
                print("\n (STEP 4Z/33) OF TEST_TOKEN4XI *** FAILED TO GET A SERVER OBJECT server2xi: ", server2xi)
                print('=' *33)
                #        
        else:
            print('~' *33)
            print("\n (STEP 4/33d) ** SKIPPED GETTING A SERVER OBJECT FROM MANAGER OBJECT manager2xi: ", manager2xi)
            print('~' *33)   
                       
        # ---------------------------------------------------------------------------------------------
        # (STEP 5/33) - CONNECTING A MANAGER OBJECT                  
        # ---------------------------------------------------------------------------------------------   
        ack2connect = False
        
        if ack2server is True:            
            
            try:
                print('=' *33)
                print("\n (STEP 5A/33) OF TEST_TOKEN4XI - CONNECTING A MANAGER OBJECT: ", manager2xi, " TO THE SERVER OBJECT: ", server2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30>  TO THE SERVER OBJECT:  <server4xi.Server4Xi object at 0x0000000003CBABE0>     
                        
                manager2xi.connect() 
                
                ack2connect = True
                
                print('=' *33)
                print("\n (STEP 5B/33) OF TEST_TOKEN4XI - CONNECTED A MANAGER OBJECT: ", manager2xi, " TO THE SERVER OBJECT: ", server2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30>  TO THE SERVER OBJECT:  <server4xi.Server4Xi object at 0x0000000003CBABE0>
            except:
                print('=' *33)
                print("\n (STEP 5C/33) OF TEST_TOKEN4XI - *** FAILED TO CONNECTED A MANAGER OBJECT: ", manager2xi, " TO THE SERVER OBJECT: ", server2xi)
                print('=' *33)               
        

        else:
            print('~' *33)
            print("\n (STEP 5Z/33) OF TEST_TOKEN4XI - ** SKIPPED CONNECTING A MANAGER OBJECT: ", manager2xi, " TO THE SERVER OBJECT: ", server2xi)
            print('~' *33)           
           
        # ---------------------------------------------------------------------------------------------
        # (STEP 6/33) OF TEST_TOKEN4XI - JOINS EVEN WITHOUT SERVER !                         
        # ---------------------------------------------------------------------------------------------   
        if ack2manager is True:
        
            try:    
                print('=' *33)
                print("\n (STEP 6A/33) OF TEST_TOKEN4XI - JOINING THE MANAGER PROCESS: ", manager2xi, " WITH THE SERVER OBJECT: ", server2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30>  WITH THE SERVER OBJECT:  <server4xi.Server4Xi object at 0x0000000003CBABE0>     
                        
                manager2xi.join() 
                            
            
                print('=' *33)
                print("\n (STEP 6B/33) OF TEST_TOKEN4XI - JOINED THE MANAGER PROCESS: ", manager2xi, " WITH THE SERVER OBJECT: ", server2xi)
                print('=' *33)
                # <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30>  WITH THE SERVER OBJECT:  <server4xi.Server4Xi object at 0x0000000003CBABE0>
                
            except:
                print('=' *33)
                print("\n (STEP 6C/33) OF TEST_TOKEN4XI - *** FAILED TO JOIN THE MANAGER PROCESS: ", manager2xi, " WITH THE SERVER OBJECT: ", server2xi)
                print('=' *33)            
                    
        else:
            print('~' *33)
            print("\n (STEP 6Z/33) OF TEST_TOKEN4XI - ** SKIPPED JOINING THE MANAGER PROCESS: ", manager2xi, " WITH THE SERVER OBJECT: ", server2xi)
            print('~' *33)          
           
        # ---------------------------------------------------------------------------------------------
        # (STEP 7/33) OF TEST_TOKEN4XI - SENSING MANAGER                     
        # ---------------------------------------------------------------------------------------------   
        if ack2manager is True:
            try: 
                print('=' *33)        
                print("\n (STEP 7A/33) OF TEST_TOKEN4XI - SENSED MANAGER manager2xi: ", manager2xi.sense())
                print('=' *33)
                # {      'ack2server-of-SyncManager4Xi': True, 
                #             'state-of-syncmanager2xi': <state4xi.State4Xi object at 0x02F903D0>, 
                
                #           'address-of-syncmanager2xi': None, <--- ****  
                
                #    'ack2connection-of-SyncManager4Xi': True,
                #          'Listener-of-syncmanager2xi': <class 'listener4xi.Listener4Xi'>, 
                #        'serializer-of-syncmanager2xi': 'pickle', 
                #                              'object': <syncmanager4xi.SyncManager4Xi object at 0x02D3CBD0>, 
                
                #           'authkey-of-syncmanager2xi': None, <--- ****
                 
                #          'registry-of-SyncManager4Xi': {'AsyncResult': (None, None, None, <function AutoProxy4Xi at 0x02DDE5D0>), 
                #                                        'Condition4Xi': (<function Condition at 0x02747D68>, ('wait', 'notify', 'notify_all', 'sense', 'reason', 'ace'), None, <class 'conditionproxy4xi.ConditionProxy4Xi'>),
                #                                            'Event4Xi': (<function Event at 0x027594B0>, ('is_set', 'set', 'clear', 'wait', 'sense', 'reason', 'ace'), None, <class 'eventproxy4xi.EventProxy4Xi'>), 
                #                                            'Iterator': (None, ('send', 'throw', 'close', 'sense', 'reason', 'ace'), None, <class 'iteratorproxy4xi.IteratorProxy4Xi'>), 
                #                                 'BoundedSemaphore4Xi': (<function BoundedSemaphore at 0x02759348>, ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
                #                                            'Array4Xi': (<function Array4Xi at 0x02DC56F0>, ('__len__', '__getitem__', '__setitem__'), None, <class 'arrayproxy4xi.ArrayProxy4Xi'>), 'list': (<class 'list'>, ('sense', 'reason', 'ace'), None, <class 'listproxy4xi.ListProxy4Xi'>), 
                #                                            'Queue4Xi': (<class 'queue.Queue'>, None, None, <function AutoProxy4Xi at 0x02DDE5D0>), 
                #                                             'Pool4Xi': (<class 'pool4xi.Pool4Xi'>, ('apply', 'apply_async', 'close', 'imap', 'imap_unordered', 'join', 'map', 'map_async', 'terminate', 'sense', 'reason', 'ace'), {'apply_async': 'AsyncResult', 'imap_unordered': 'Iterator', 'imap': 'Iterator', 'map_async': 'AsyncResult'}, <class 'poolproxy4xi.PoolProxy4Xi'>), 
                #                                             'Lock4Xi': (<built-in function allocate_lock>, ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
                #                                        'Semaphore4Xi': (<function Semaphore at 0x02759030>, ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
                #                                            'RLock4Xi': (<function RLock at 0x02747D20>, ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>),
                #                                                'dict': (<class 'dict'>, ('__contains__', '__delitem__', '__getitem__', '__len__', '__setitem__', 'clear', 'copy', 'get', 'has_key', 'items', 'keys', 'pop', 'popitem', 'setdefault', 'update', 'values', 'sense', 'reason', 'ace'), None, <class 'dictproxy4xi.DictProxy4Xi'>), 
                #                                    'JoinableQueue4Xi': (<class 'queue.Queue'>, None, None, <function AutoProxy4Xi at 0x02DDE5D0>), 
                #                                            'Value4Xi': (<class 'value4xi.Value4Xi'>, ('get', 'set', 'sense', 'reason', 'ace'), None, <class 'valueproxy4xi.ValueProxy4Xi'>), 
                #                                        'Namespace4Xi': (<class 'namespace4xi.Namespace4Xi'>, ('__getattribute__', '__setattr__', '__delattr__', 'sense', 'reason', 'ace'), None, <class 'namespaceproxy4xi.NamespaceProxy4Xi'>)}, 
                #                            'Server-of-SyncManager4Xi': <class 'server4xi.Server4Xi'>, 
                #                            'Client-of-syncmanager2xi': <function Client4Xi at 0x02D3F4F8>}
        
            except:
                pass
                
        if ack2server is True:
            try:                 
                
                print('=' *33)        
                print("\n (STEP 7B/33) OF TEST_TOKEN4XI - SENSED SERVER server2xi: ", server2xi.sense())
                print('=' *33)        
            except:
                pass
                    
        # ---------------------------------------------------------------------------------------------
        # (STEP 8/33)                       
        # ---------------------------------------------------------------------------------------------   
        if ack2manager is True:             
            try:
                print('=' *33)        
                print("\n (STEP 8A/33) OF TEST_TOKEN4XI - REASONING MANAGER manager2xi: ", manager2xi.reason())
                print('=' *33)
                # {'object-reason-object4xi': <syncmanager4xi.SyncManager4Xi object at 0x0000000002AD5C50>}   
            except:
                pass
                
        if ack2server is True:
            try:                 
                               
                print('=' *33)        
                print("\n (STEP 8B/33) OF TEST_TOKEN4XI - REASONED SERVER server2xi: ", server2xi.reason())
                print('=' *33)        
            except:
                pass
                                   
        # ---------------------------------------------------------------------------------------------
        # (STEP 9/33)                    
        # ---------------------------------------------------------------------------------------------   
        if ack2manager is True:
            try:        
                print('=' *33)            
                print("\n (STEP 9A/33) OF TEST_TOKEN4XI - ACING MANAGER manager2xi: ", manager2xi.ace())
                print('=' *33)
                # {'object8xi': <syncmanager4xi.SyncManager4Xi object at 0x0000000003CBAD30>} 
            except:
                pass 
                       
        if ack2server is True:
            try:                 
                              
                print('=' *33)            
                print("\n (STEP 9B/33) OF TEST_TOKEN4XI - ACED SERVER server2xi: ", server2xi.ace())
                print('=' *33)
                # {'object8xi': <server4xi.Server4Xi object at 0x0000000003CBABE0>}       
            except:
                pass           
    except:
        # ---------------------------------------------------------------------------------------------    
        # (STEP 10/33) OF TEST_TOKEN4XI -EXCEPTIONS
        # ---------------------------------------------------------------------------------------------          
        print('=' *33)        
        print("\n (STEP 10Z/33) OF TEST_TOKEN4XI - HIT EXCEPTIONS BY TEST_TOKEN4XI - TO BE SOLVED ***")
        print('=' *33)
          
                
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # (STEP 11/33) OF TEST_TOKEN4XI -PRINT TRACE 
        # ---------------------------------------------------------------------------------------------     
        print('=' *33)        
        print("\n (STEP 11Z/33) OF TEST_TOKEN4XI - STARTING TO PRINT TRACE")
        print('=' *33)        
        
        print_trace4xi(t2xi)   
        
        return
        
#</function4xi>        
             

                           
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing Token4Xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                                
# -------------------------------------------------------------------------------------------------    
def main():

    
    print('=' *33)
    print("\n STARTING TESTING TOKEN4XI.PY ", time4xi())
    print('=' *33)
    
       
    test_token4xi()
 

    print('=' *33)
    print("\n COMPLETED TESTING TOKEN4XI.PY ", time4xi())
    print('=' *33)
#</function4xi>
                
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

#</program4xi>    
# -------------------------------------------------------------------------------------------------
# History of public_methods4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_token4xi.txt
#   sense-token4xi.xml
#   reason-token4xi.xml
#   ace-token4xi.xml


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_token4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

